import java.util.Iterator;

/**
 * Created by Heraldo on 28.06.2015.
 */
public class Main {

    public static void main(String[] args) {
        SortedList list = new SortedList();
        Person p = null;
        for (int i = 0; i < 20; i++) {
            p = new Person("Person" + i);
            list.add(p);
        }



        try {
            foo(null);
        }
        catch (RepException re) {
            System.out.println("RepException: " + re.getMessage());
        }
        catch (NullPointerException ne) {
            System.out.println("NullPointer: " + ne.getMessage());
        }

        try {
            foo(list);
        }
        catch (RepException re) {
            System.out.println("RepException: " + re.getMessage());
        }
        catch (NullPointerException ne) {
            System.out.println("NullPointer: " + ne.getMessage());
        }

        System.out.println("\nPrinting persons:");
        for (Iterator<Person> iter = list.iterator(); iter.hasNext(); )
            System.out.print(iter.next());
    }

    private static void foo(SortedList list) throws RepException {
        if(list == null)
            throw new NullPointerException("List is null!");
        testing(list);
    }

    private static void testing(SortedList list) throws RepException {
        try {
            list.add(new Person(null, null));
        }
        catch(IllegalArgumentException ie) {
            throw new RepException("IllegalArgument: " + ie.getMessage());
        }
    }
}
