/**
 * Created by Heraldo on 28.06.2015.
 */
public abstract class Being implements Moveable{

    protected final String name;
    protected final float height;
    protected final float weight;

    public Being(String name, float height, float weight) {
        this.name = name;
        this.height = height;
        this.weight = weight;
    }

    public String getName() {
        return name;
    }

    public float getHeight() {
        return height;
    }

    public float getWeight() {
        return weight;
    }

    @Override
    public String toString() {
        return String.format("%s, %.2f tall, %.2f heavy", name, height, weight);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;

        if (o instanceof Being) {

            Being being = (Being) o;

            return name.equals(being.name) && height == being.height && weight == being.weight;
        }

        return false;
    }
}
