import java.util.ArrayList;
import java.util.Iterator;

/**
 * Created by Heraldo on 28.06.2015.
 */
public class Main {

    public static void main(String[] args) {
        Pet pet = new Dog("DogA");
        Being being = new Person("PersonA", pet);
        pet.setOwner((Person)being);
        System.out.print("being: " + being);
        System.out.println("pet: " + pet);


        Dog dog = new Dog((Dog)pet);
        Person person = dog.getOwner();
        System.out.print("dog: " + dog);
        System.out.println("person: " + person);

        Person person2 = new Person((Person) being);
        Pet pet2 = person2.getPet();
        System.out.print("person2: " + person2);
        System.out.println("pet2: " + pet2);


        SortedList<Person> list = new SortedList<Person>();
        for(int i = 0; i < 20; i++)
            list.add(new Person("Person" + i));

        SortedList<Dog> listD = new SortedList<Dog>();
        for(int i = 0; i < 20; i++)
            listD.add(new Dog("Dog" + i));

        System.out.println("Dogs: ");
        for(Iterator<Dog> iter = listD.iterator(); iter.hasNext();) {
            System.out.print(iter.next());
        }

        System.out.println("\nPersons: ");
        for(Iterator<Person> iter = list.iterator(); iter.hasNext();) {
            System.out.print(iter.next());
        }

        ArrayList<Being> beingList = new ArrayList<>();
        beingList.add(being);
        beingList.add(dog);
        beingList.add(person);
        beingList.add(person2);
        beingList.add((Being)pet);
        beingList.add((Being)pet);

        System.out.println("\nBeings: ");
        for(Iterator<Being> iter = beingList.iterator(); iter.hasNext();) {
            System.out.print(iter.next());
        }
    }
}
